from graph import *

def laenge(g, rundreise):
    weglaenge = 0
    anzahlKnoten = len(rundreise)
    i = 1
    while i < anzahlKnoten:
        weglaenge = weglaenge + float(g.getGewichtKante(rundreise[i-1], rundreise[i]))
        i = i+1
    return weglaenge

def rundreiseNaeherung1(g, startKnoten):
    route = [startKnoten]
    knotenRestListe = []
    for knoten in g.getAlleKnoten():
        if knoten != startKnoten:
            knotenRestListe = knotenRestListe + [knoten]
    while knotenRestListe != []:
        aktuellerKnoten = route[len(route)-1]
        minKnoten = knotenRestListe[0]
        minAbstand = float(g.getGewichtKante(aktuellerKnoten, minKnoten))
        for knoten in knotenRestListe[1:]:
            abstandKnoten = float(g.getGewichtKante(aktuellerKnoten, knoten))
            if abstandKnoten < minAbstand:
                minKnoten = knoten
                minAbstand = abstandKnoten
        route = route + [minKnoten]
        knotenRestListeNeu = []
        for knoten in knotenRestListe:
            if knoten != minKnoten:
                knotenRestListeNeu = knotenRestListeNeu + [knoten]
        knotenRestListe = knotenRestListeNeu
    route = route + [startKnoten]
    laengeRoute = laenge(g, route)
    return (route, laengeRoute)

def minimalerAbstand(g, aktuellerKnoten, knotenListe):
    if knotenListe != []:
        minKnoten = knotenListe[0]
        minAbstand = float(g.getGewichtKante(aktuellerKnoten, minKnoten))
        for knoten in knotenListe[1:]:
            abstand = float(g.getGewichtKante(aktuellerKnoten, knoten))
            if abstand < minAbstand:
                minKnoten = knoten
                minAbstand = abstand
        return (minKnoten, minAbstand)
    else:
        return (None, None)

def maximalerAbstand(g, vonKnotenListe, inKnotenListe):
    if vonKnotenListe != []:
        maxKnoten = vonKnotenListe[0]
        (k, maxAbstand) = minimalerAbstand(g, maxKnoten, inKnotenListe)
        for knoten in vonKnotenListe[1:]:
            (k, abstand) = minimalerAbstand(g, knoten, inKnotenListe)
            if abstand > maxAbstand:
                maxKnoten = knoten
                maxAbstand = abstand
        return (maxKnoten, maxAbstand)
    else:
        return (None, None)

def minimalEinfuegen(g, knoten, rundkurs):
    position = 1
    rundkursMitKnoten = rundkurs[0:position] + [knoten] + rundkurs[position:len(rundkurs)]
    minLaenge = laenge(g, rundkursMitKnoten)
    minRundkurs = rundkursMitKnoten
    position = 2
    while position < len(rundkurs):
        rundkursMitKnoten = rundkurs[0:position] + [knoten] + rundkurs[position:len(rundkurs)]
        neueLaenge = laenge(g, rundkursMitKnoten)
        if neueLaenge < minLaenge:
            minLaenge = neueLaenge
            minRundkurs = rundkursMitKnoten
        position = position + 1
    return minRundkurs
  
def rundreiseNaeherung2(g, startKnoten):
    rundreisegeruest = [startKnoten, startKnoten]
    knotenRestListe = []
    for knoten in g.getAlleKnoten():
        if knoten != startKnoten:
            knotenRestListe = knotenRestListe + [knoten]
    while knotenRestListe != []:
        (maxKnoten, maxAbstand) = maximalerAbstand(g, knotenRestListe, rundreisegeruest)
        rundreisegeruest = minimalEinfuegen(g, maxKnoten, rundreisegeruest)
        knotenRestListeNeu = []
        for knoten in knotenRestListe:
            if knoten != maxKnoten:
                knotenRestListeNeu = knotenRestListeNeu + [knoten]
        knotenRestListe = knotenRestListeNeu
    route = rundreisegeruest
    laengeRoute = laenge(g, route)
    return (route, laengeRoute)

def naechste_permutation(L):
    # bestimme den maximalen Index i mit L[i] < L[i+1]
    i = len(L)-2
    gefunden = False
    while not gefunden:
        if i < 0:
            gefunden = True
        else:
            if L[i] < L[i+1]:
                gefunden = True
            else:
                i = i-1
    if i >= 0:
        # bestimme den maximalen Index j mit L[j] > L[i]
        j = i+1
        m = j
        while j < len(L)-1:
            j = j+1
            if L[j] > L[i]:
                m = j
        j = m
        # vertausche L[i] und L[j]
        h = L[i]
        L[i] = L[j]
        L[j] = h
        # kehre die Restliste ab Position i+1 um
        i = i+1
        j = len(L)-1
        while i < j:
            h = L[i]
            L[i] = L[j]
            L[j] = h
            i = i+1
            j = j-1
    else:
        # Liste ist absteigend sortiert
        # kehre Liste um
        i = 0
        j = len(L)-1
        while i < j:
            h = L[i]
            L[i] = L[j]
            L[j] = h
            i = i+1
            j = j-1
    return L
   
def minimaleRundreise(g, startKnoten):
    startRouteOhneStartKnoten = []
    for knoten in g.getAlleKnoten():
        if knoten != startKnoten:
            startRouteOhneStartKnoten = startRouteOhneStartKnoten + [knoten]
    startRoute = [startKnoten] + startRouteOhneStartKnoten + [startKnoten]
    routeOhneStartKnoten = startRouteOhneStartKnoten[:]
    route = startRoute
    minLaenge = laenge(g, route)
    minRoute = route
    endePermutationen = False
    while not endePermutationen:
        routeOhneStartKnoten = naechste_permutation(routeOhneStartKnoten)
        route = [startKnoten] + routeOhneStartKnoten + [startKnoten]
        if laenge(g, route) < minLaenge:
            minLaenge = laenge(g, route)
            minRoute = route
        endePermutationen = (routeOhneStartKnoten == startRouteOhneStartKnoten)
    return (minRoute, minLaenge)


# Erzeugung des Graph-Objekts
g = GraphMitDaten()
# Erzeugung der Knoten und Kanten aus einer GraphML-Datei
datei = open("graph_eu_27.xml", "r")
xml_quelltext = datei.read()
g.graphmlToGraph(xml_quelltext) 
# Test der Rundreise-Algorithmus
# exakte Lösung
'''print('kürzeste Rundreise')
(minRoute, minLaenge) = minimaleRundreise(g, 'Bonn')
print('Route:', minRoute)
print('Länge:', minLaenge)'''
# Näherungsverfahren 1
print('Näherungslösung 1')
(minRoute, minLaenge) = rundreiseNaeherung1(g, 'Berlin')
print('Route:', minRoute)
print('Länge:', minLaenge)
# Näherungsverfahren 2
print('Näherungslösung 2')
(minRoute, minLaenge) = rundreiseNaeherung2(g, 'Berlin')
print('Route:', minRoute)
print('Länge:', minLaenge)

